#include "gsys-aumann.h"

#include <stdarg.h>

GameDescription 	gamed;
Ucache_manager_cm	ucache;

FILE	*out_copy = fopen("stdout.txt", "wt");

char	sb_name[100] = "gmain.game";

int	zprintf(const char *fmt, ...)
{	
	va_list list;

	if (out_copy) {
		va_start(list, fmt);
		vfprintf(out_copy, fmt, list);
	}

	va_start(list, fmt);
	vfprintf(stdout, fmt, list);
	va_end(list);
}




void	load_game_format_iter(Profile *prof, int level, FILE *sb)
{
	int pl;
	if (level == prof->gamed->N) {
		float us;
		prof->become_from_addr();
		for ( pl=0; pl<prof->gamed->N; pl++) {

			fscanf(sb, "%f", &us); 
			assert(!feof(sb));

			prof->U[pl] = us;
			ucache.put_seq(prof->num, prof);
		}

		//prof->printAll(true);

		return ;
	}

	int	maxa = prof->gamed->nstrats(level);

	for (prof->Addr[level]=0; prof->Addr[level]<maxa; prof->Addr[level]++) {
		load_game_format_iter(prof, level+1, sb);
	}
}


void	load_game_format(char *fn)
{
	FILE	*sb = fopen(fn, "rt");
	assert(sb!=0);

	fscanf(sb, "%d", &gamed.N);
	int pl, snum;

	zprintf("Loading a game of %d players with: ", gamed.N);
	for (pl=0; pl<gamed.N; pl++) {
		fscanf(sb, "%d", &snum);
		gamed.put_strategies_n(pl, snum);
		zprintf("%d ", snum);
	}
	gamed.prepare();
	zprintf(" strategies\n");

	Profile	prof(&gamed);
	load_game_format_iter(&prof, 0, sb);
	zprintf("Game loaded\n");

	fclose(sb);
}


int	main(int argc, char *argv[])
{
	zprintf("CE-Solver v0.1, Sep 2008, Martin Hruby, FIT BUT, hrubym@fit.vutbr.cz\n");
	init_gamelib();

	if (argv[1]!=0) strcpy(sb_name, argv[1]);

	load_game_format(sb_name);

	CorrSolver ce(&gamed, &ucache, 0);
	//ce.divider = 10000;
	ce.texto = true;
	ce.MAXcpus = 8;

	ce.work();
	CorrSolution	sol;
	ce.export_solution(sol);
	sol.print(stdout, &gamed);
}
