#ifndef	__GSYS_AUMANN_H
#define	__GSYS_AUMANN_H

#include "optim.h"
//#include "game-computing.h"

class	LPvar_cs : public LP_var {
public:
	LPvar_cs(Profile *prf) : LP_var() {
		prof=prf;
		assert(prof!=0);
		iod=0; ido=1.0;
		probable = true;
	}

	Profile	*prof;
	bool	probable;
};

typedef	std::vector<LPvar_cs> LPvar_csy;
typedef	std::vector<LPvar_cs>::iterator LPvar_csy_i;

class	EqSolver {
public:
	EqSolver(GameDescription *gd, Ucache_manager_cm *ucan, cellModel *cm) {
		gamed=gd;
		ucache=ucan;
		cellM=cm;
		solution_p = -1;
		texto=true;
		MAXcpus = 1;
	}

	virtual	bool	work() { return false; }

		
	GameDescription *gamed;
	Ucache_manager_cm *ucache;
	cellModel	*cellM;
	longcis solution_p;
	bool	texto;
	int	MAXcpus;
};


struct	CorrSolution {
	CorrSolution() {
	}

	void	print(FILE *sb, GameDescription *gamed) {
		fprintf(sb, "%d items in the stochastic profile\n", itemy.size());
		Profile prof(gamed);
		for (PR_itemy_i i=itemy.begin(); i!=itemy.end(); i++) {
			prof.become_num(i->key);
			fprintf(sb, "profile num: "); std::cout << i->key;
			fprintf(sb, " [ "); prof.printAddr(false);
			fprintf(sb, " ] ");
			fprintf(sb, "%.2f\n", i->prob);
		}
	}

	PR_itemy itemy;
	longcis solution_p;
};


class	CorrSolver : public EqSolver {
public:
	CorrSolver(GameDescription *gd, Ucache_manager_cm *ucan, cellModel *cm) : EqSolver(gd, ucan, cm) {
		divider = 1;
		nu=nenu=0;
	}

	real	uZ(LPvar_cs *lp) {
		real z=0;
		for (int a=0; a<gamed->N; a++)
			z += lp->prof->U[a];
		return z;
	}

	virtual	bool	work();

	void	create_vary(Profile *prof, int lev, LP_vary &vary);
	void	save_g();

	void	export_solution(CorrSolution &sol);

	//MLP_max	mlp;

	real	divider;
	ProgRND	rnd;
	Intvector	strats_v[MAXplayers];
	int	nu,nenu;
};


class	StackelberSolver : public EqSolver {
public:
	StackelberSolver(GameDescription *gd, Ucache_manager_cm *ucan, cellModel *cm) : EqSolver(gd, ucan, cm) {
	}

	virtual	bool	work();

};

#endif

