


#ifndef	__MUJ_POOL_H
#define	__MUJ_POOL_H
 
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include <vector>

typedef	std::vector<char *> Chary;
typedef	std::vector<char *>::iterator Chary_i;

template <typename coto>
class	Mujpul {
public:
    typedef coto mujtyp;
    typedef std::vector<mujtyp *> store;
    
    Mujpul(int sts, bool dyna=false) {
        dynamic = dyna;
	size_allocated = 0;
	size_blk = sts;
	pridej_block();
    }

	void pridej_block() {
		char *block = (char *)::malloc(sizeof(mujtyp)*size_blk);
		assert(block!=0);
		blocky.push_back(block);
		for (int a=0; a<size_blk; a++) {
	 		mujstore.push_back(mapa(block, a));
		}
		size_allocated += size_blk;
	}

Mujpul(Mujpul &cd) {
	zprintf("Kopiruje\n");
}
    
    ~Mujpul() {
	for (Chary_i ch=blocky.begin(); ch!=blocky.end(); ch++) 
		::free((void*)*ch);
	//zprintf("!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
	mujstore.clear();
    }
    
    mujtyp *mapa(char *blk, int idx) { return (mujtyp*)(blk + (sizeof(mujtyp)*idx)); }
    
    bool available() { 
	
	if ( mujstore.size()>0 ) return true;
	if (dynamic) {
		pridej_block();
		return true;
	} else return false;
	}
   int free_count() { return mujstore.size(); }
    
    mujtyp *malloc() {
	assert(available());
	mujtyp *tm = mujstore.back();
	mujstore.pop_back();
	//zprintf("Naba store-beru: %d\n", mujstore.size()+1);
	new (tm) mujtyp();
	return tm;
    }
    
    void freeit(mujtyp *kt) { 
		//zprintf("Naba store: %d\n", mujstore.size()+1);
		mujstore.push_back(kt); 
		assert(mujstore.size()<=size_allocated);
	}
        
    int	size_allocated, size_blk;
   Chary blocky;
    store mujstore;
	bool dynamic;
};


#endif
