
#include "optim.h"

int	LP_solv_cc=0;


void	LP_var::gener(LP_solver &slv) 
{
	//zprintf("Generuju prom %d %.0f %.0f z=%.0f\n", id, iod, ido, z_coef);

	//lpx_set_col_kind(slv.lp, id, LPX_CV);
	if (iod==ido)
		lpx_set_col_bnds(slv.lp, id, LPX_FX , iod, ido);
	else
		lpx_set_col_bnds(slv.lp, id, LPX_DB, iod, ido);

	lpx_set_obj_coef(slv.lp, id, z_coef);	
}



void	LP_var::svalue(float v) 
{	
	value = v;
	assert(v>= iod && v<= ido);
	if (value<iod) value=iod;
	if (value>ido) value=ido;
}



void	LP_nerovn::gener(LP_solver &slv)
{
	//zprintf("Je tu radek %d cd=%d, meze=%.0f,%.0f refy.size=%d\n", radek, cd, iod, ido, of.size());

	if (cd == LPX_DB) {
	
		if (iod==ido)
			lpx_set_row_bnds(slv.lp, radek, LPX_FX, iod, ido);
		else
			lpx_set_row_bnds(slv.lp, radek, LPX_DB, iod, ido);

	} else 
		lpx_set_row_bnds(slv.lp, radek, cd, iod, ido);
	
	
	for (LP_refy_i r=of.begin(); r!=of.end(); r++) {
		if (r->var->id>0 && r->var->z_coef!=0) {
			//zprintf("radek %d => %.3f/%.2f(%d) %d \n", radek, r->coef , r->var->z_coef, r->var->id, slv.ida);//, r->var->mas->id);
			slv.matrix_put_new(radek, r->var->id, r->coef);
		}
	}
	

	//zprintf(" <= %.0f %.0f\n", iod, ido);
	
}



bool	LP_solver::work() {
		if (flag_out)
			lpx_set_int_parm(lp, LPX_K_MSGLEV, 3);
		else
			lpx_set_int_parm(lp, LPX_K_MSGLEV, 0);
	
//		lpx_set_int_parm(lp, LPX_K_PRESOL, 1);

		lpx_load_matrix(lp, ida, ia, ja, ar);
		
		int lres;
		
		lres = lpx_simplex(lp);

#ifdef	MUSI_SKONCIT_DOBRE
		if (lres!=0) { 
			zprintf("LP-task has wrong specification\n"); 
			return false; 
		}
		lres = lpx_get_status(lp);



		//zprintf("%d %d lres\n", lres, LPX_OPT);
		if (lres!=LPX_OPT && lres!=LPX_FEAS) {
			zprintf("!!!!!!!!!!!!!!!!!!!!!!! NO SOLUTION \n");
			exit(1);
			return false;
		}
#endif

/*		
if (Mipjo) {
		lpx_set_int_parm(lp, LPX_K_MSGLEV, 0);
		if (flag_out)
			lpx_set_int_parm(lp, LPX_K_MSGLEV, 3);
		lres = lpx_integer(lp);
		lres = lpx_mip_status(lp);
		//zprintf("LRES: %d\n", lres);
		if (!(lres==LPX_I_FEAS || lres==LPX_I_OPT)) {
			zprintf("!!!!!!!!!!!!!!!!!!!!!!! NEMA INTEGER SOLUTION \n");
			return false;
		}
		
}
		
		
		Z = lpx_mip_obj_val(lp);
		//zprintf("ZET: %f\n", Z);

*/

		Z = lpx_get_obj_val(lp);
		
		for (int m=0; m<vars; m++) {
			//zprintf("Col: %d  ", lpx_get_col_kind(lp,m+1));
			
			vary[m]->svalue(lpx_get_col_prim(lp,m+1));

		}
		
		return true;
	}


